
####################################################
# Instrukciók magyarul az angol nyelvű leírás után #
####################################################

##################
# Installation 1 #
##################
 Create a new directory named "LiquidCrystal_I2C_CH55X_HUN" in the sketchbook 
 path specified in the Arduino IDE settings menu within the "libraies" 
 directory. Copy the contents of the ZIP file. After restarting the 
 Arduino IDE, you will find a detailed sample example in File / Examples.

##################
# Installation 2 #
##################
 In the Arduino IDE Sketch / Library Content menu, use Add ZIP Library 
 to browse to the ZIP file and add it. After restarting the Arduino IDE, 
 you will find a detailed sample example in File / Examples.

#####################################################
# Differences from standard LiquidCrystal libraries #
#####################################################
- Begin downloads the Hungarian accented lowercase letters to the 
  display for ASCII codes 0-6 (ö and ü are in the display's own ASCII 
  character table.
- Handles lowercase letters with Hungarian accents, automatically 
  replaces uppercase letters with small ones.
- The usual print and println functions were not implemented, they were 
  created as individual functions for the formatted output of some data 
  types.

################################
# Display controller functions #
################################

begin(byte, byte, byte)
  Resets the display, uploads Hungarian characters
-------------------------------------------------------------
clear()
  Erases the contents of the display, puts the cursor 
  at 0.0 points
-------------------------------------------------------------
home()
------
  Places the cursor at 0.0 points
-------------------------------------------------------------
noDisplay()
  Turns off the display (ram content is preserved, 
  unchanged when turned on)
-------------------------------------------------------------
display()
  Turns on the display
-------------------------------------------------------------
off()
  Same as noDisplay but also turns off the backlight
-------------------------------------------------------------
on()
  Turns on the display and backlight
-------------------------------------------------------------
noBlink()
  Turns off flashing full character in cursor position
-------------------------------------------------------------
blink()
  Turns on flashing full character in cursor position
-------------------------------------------------------------
noCursor()
  Turns off the underscore cursor indicator in the cursor 
  position
-------------------------------------------------------------
cursor()
  Turns on the underscore cursor indicator in the cursor 
  position
-------------------------------------------------------------
scrollDisplayLeft()
  Scrolls the display content one character to the left 
  (character exiting at the end enters at the other end)
-------------------------------------------------------------
scrollDisplayRight()
--------------------
  Scrolls the display content one character to the left 
  (character exiting at the end enters at the other end)
-------------------------------------------------------------
leftToRight()
  The characters of the following writings are displayed 
  from left to right (normal writing direction). In the 
  case of autoscroll, the display will scroll to the left.
-------------------------------------------------------------
rightToLeft()
  The characters of the following writings appear from right 
  to left (opposite writing direction). With autoscroll, 
  the display will scroll to the right.
-------------------------------------------------------------
noBacklight()
  Turn off backlight
-------------------------------------------------------------
backlight()
  Turn on backlight
-------------------------------------------------------------
setBacklight(byte)
  Turn backlight on or off (0 off, 1 on)
-------------------------------------------------------------
getBacklight()
  Returns the backlight status in bool type (0 does not 
  light up, 1 lights up)
-------------------------------------------------------------
autoscroll()
  After writing out a character, it is not the cursor 
  that moves, but the entire display with content shift.
-------------------------------------------------------------
noAutoscroll()
  When a character is written out, the cursor moves.
-------------------------------------------------------------
createChar(byte, byte[])
  Upload character. First parameter storage space (0-7), 
  second is an 8-element array with the character image 
  (5x8 character dot matrix)
-------------------------------------------------------------
setCursor(byte, byte)
  Cursor position adjustment (column, row)

#######################
# Data dump functions #
#######################

write(byte)
  Writing a character. as parameter, enter an ASCII code 
  (e.g. letter A is 65)
-------------------------------------------------------------
print(char)
  It prints an array of characters. The dump is done on a 
  character-by-character basis using the Write method. The 
  UTF-8 encoded 195 or 197 introductory bytes of Hungarian 
  accented characters are not sent to the display. The 
  subsequent code is converted to the corresponding ascii 
  code 0-6.
-------------------------------------------------------------
print_long(long,byte, bool)
  Displays the value of a variable of type Long. The second 
  parameter is the minimum length of the dump, if the number 
  is shorter than this, it is filled with spaces. If it is 
  longer, then it is not truncated. If the second parameter 
  is 0, then it is written exactly in the required length. 
  The third parameter fills the number with spaces for 0 when 
  specifying length, if 1, then with 0.
-------------------------------------------------------------
print_float(float,byte,byte,bool)
  Displays the value of a float variable. The second parameter 
  is the minimum length of the whole part (for 0, it is written 
  out exactly in the required length. The third parameter is 
  the number of digits in the decimal part. For 0, there is no 
  decimal place (no decimal point). Rounds to the last decimal 
  place. Fourth parameter for 0 fills the number with spaces 
  when specifying length, if 1, then with 0.
-------------------------------------------------------------
print_date(int,byte,byte,bool)
  Displays a date in the format yyy.mm.dd or yyyy.mm.dd. The 
  first parameter is the year, the second is the month, the 
  third is the day. The fourth parameter is the century 
  specification (for 1). Then the year should be entered in 
  4 digits (e.g. 2022). If this parameter is 0, then the year 
  must be given on two digits (for example, 22).
-------------------------------------------------------------
print_time(byte,byte,byte,bool)
  It writes out time in the format hh:mm:mm or hh:mm. The 
  first parameter is the hour, the second is the minute, 
  the third is the second.Fourth parameter for 0 is the 
  second ":" and second does not write it out, but the 
  parameter must be specified, its value indifferent. 
  If the parameter value is 1, it also prints the second.


########################################################################
# description in Hungarian                                             #
########################################################################

#################
# Installáció 1 #
#################
  Készíts egy új könyvtárat "LiquidCrystal_I2C_CH55X_HUN" névvel az 
  Arduino IDE program beállítások menüpontjában megadott 
  vázlatfüzet elérési útvonalon a "libraies" könyvtáron belül.
  Másold bele a ZIP file tartalmát. Arduino IDE újraindítása 
  után a Fájl / Példák menüpontban részletes mintapéldát találsz.

#################
# Installáció 2 #
#################
  Az Arduino IDE Vázlat / Könyvtár tartalom menüpontjában ZIP 
  könyvtár hozzáadása menüponttal tallózd ki a ZIP állományt, 
  és add hozzá. Arduino IDE újraindítása után a Fájl / Példák 
  menüpontban részletes mintapéldát találsz.

####################################################
# Eltérések a szokásos LiquidCrystal könyvtáraktól #
#################################################### 
- A begin letölti a magyar ékezetes kisbetűket a kijelzőre a 
  0-6 ASCII kódokra (ö és ü betű benn van a kijelző saját
  ASCII karaktertáblájában.
- Magyar ékezetes kisbetűket kezel, nagybetűket automatikusan 
  kicsire cseréli. 
- Nem a szokásos print és println függvények lettek 
  megvalósítva, minden néhány adattípus formázott 
  kiírásához egyedi függvéynek készültek. 

##############################
# Kijelző vezérlő függvények #
##############################

begin(byte,byte,byta)
  Alaphelyzetbe állítja a kijelző, feltölti a magyar 
  karaktereket
-------------------------------------------------------------
clear()
  Törli a kijelző tartalmát, a cursort a 0,0 pontra 
  helyezi
-------------------------------------------------------------
home()
  A cursort a 0,0 pontra helyezi
-------------------------------------------------------------
noDisplay()
  Kikapcsolja a kijelzőt (ram tartalma megmarad, 
  bekapcsoláskor változatlan)
-------------------------------------------------------------
display()
  Bekapcsolja a kijelzőt
-------------------------------------------------------------
off()
  Ugyanaz mint noDisplay de a háttérvilágítást is kikapcsolja
-------------------------------------------------------------
on()
  Bekapcsolja a kijelzőt és a háttérvilágítást                       
-------------------------------------------------------------
noBlink()
  Kikapcsolja a villogó telikaraktert a cursor 
  pozícióban
-------------------------------------------------------------
blink()
  Bekapcsolja a villogó telikaraktert a cursor 
  pozícióban
-------------------------------------------------------------
noCursor()
  Kikapcsolja az aláhúzás cursor jelzést a cursor 
  pozícióban
-------------------------------------------------------------
cursor()
  Bekapcsolja az aláhúzás cursor jelzést a cursor 
  pozícióban
-------------------------------------------------------------
scrollDisplayLeft()
  Egy karakterrel balra görgeti a kijelző 
  tartalmat (végen kilépő karakter a másik végen 
  belép)
-------------------------------------------------------------
scrollDisplayRight()
  Egy karakterrel balra görgeti a kijelző 
  tartalmat (végen kilépő karakter a másik végen 
  belép)
-------------------------------------------------------------
leftToRight()
  A következő írások karakterei balról jobbra 
  jelennek meg (normál írási irány). Autoscroll 
  esetén a kijelző balra gördül.
-------------------------------------------------------------
rightToLeft() 
  A következő írások karakterei jobbról balra 
  jelennek meg (ellentétes írási irány). Autoscroll 
  esetén a kijelző jobbra gördül.
-------------------------------------------------------------
noBacklight()            
  Háttérvilágítás kikapcsolása
-------------------------------------------------------------
backlight()              
  Háttérvilágítás bekapcsolása
-------------------------------------------------------------
setBacklight(byte)       
  Háttérvilágítás ki vagy bekapcsolása (0 ki, 1 be)				
-------------------------------------------------------------
getBacklight()           
  Visszaadja bool típusban a háttérvilágítás 
  állapotát (0 nem világít, 1 világít)
-------------------------------------------------------------
autoscroll()             
  Egy karakter kiírása után nem a cursor mozdul el, 
  hanem a teljes kijelző tartalom shift-el.
-------------------------------------------------------------
noAutoscroll()           
  Egy karakter kiírásakor a cursor mozdul el.
-------------------------------------------------------------
createChar(byte, byte[]) 
  Karakter feltöltése. Első paraméter tároló hely 
  (0-7), második egy 8 elemű tömb a karakterképpel 
  (5x8-as karakter pontmátrix)
-------------------------------------------------------------
setCursor(byte, byte)    
  Cursor pozíciójának beállítása (oszlop, sor)

###########################
# Adat kiírási függvények #
###########################

write(byte)
  Egy karakter írása. paraméterként ascii kódot 
  kell megadni (pl. A betű 65)
-------------------------------------------------------------
print(char)              
  Karaktertömböt ír ki. a kiírás karakterenként 
  történik a write metódussal. A magyar ékezetes 
  karakterek UTF-8 kódolású 195 vagy 197 bevezető 
  byte-ját nem küldi ki a kijelzőre. Az ezt követő 
  kódot a megfelelő 0-6 ascii kódra konvertálja.
-------------------------------------------------------------
print_long(long,byte, bool) 
  Long típusú változó értékét írja ki. A második 
  paraméter a kiírás minimális hossza, ha a szám ennél
  rövidebb, akkor szóközökkel tölti fel. Ha hosszabb,
  akkor nem csonkolja. Ha a második paraméter 0, akkor
  pontosan a szükséges hosszban történik a kiírás.
  A harmadik paraméter 0 esetén szóközökkel tölti fel 
  a számot hossz megadás esetén, ha 1, akkor 0-val. 
-------------------------------------------------------------
print_float(float,byte,byte,bool) 
  Float típusú változó értékét írja ki. Második 
  paraméter az egész rész minimális hossza (0 esetén 
  pontosan a szükséges hosszaban írja ki. Harmadik
  paraméter a tizedes rész számjegyeinek száma. 0 esetén
  nincs tizedes jegykiírás (tizedespont sem). Az utolsó
  tizedes jegy értékre kerekít. Negyedik paraméter 
  0 esetén szóközökkel tölti fel a számot hossz megadás 
  esetén, ha 1, akkor 0-val.
-------------------------------------------------------------
print_date(int,byte,byte,bool) 
  Dátumot ír ki éé.hh.nn vagy éééé.hh.nn formátumban.
  Első paraméter az év, második a hónap, harmadik a nap.
  Negyedik paraméter az évszázad kiírás (1 esetén). Ekkor
  az évet 4 számjegyen kell megadni (pl. 2022). Ha ez a 
  paraméter 0, akkor az évet két jegyen kell megadni (pl. 22). 
-------------------------------------------------------------
print_time(byte,byte,byte,bool) 
  Időt ír ki óó:pp:mm vagy óó:pp formátumban.
  első paraméter az óra, második a perc, harmadik a másodperc.
  Negyedik paraméter 0 esetén a második ":"-ot és a másodpercet
  nem írja ki, de a paramétert meg kell adni, az értéke 
  közömbös. Ha a paraméter értéke 1, akkor a másodpercet is kiírja. 
  5 karakter) 
  