#include <SoftI2C.h>
#include <LiquidCrystal_I2C_CH55X_HUN.h>

void setup() 
{
  scl_pin = 30; //SoftI2C külső változója az SCL kivezetés beállítására
  sda_pin = 31; //SoftI2C külső változója az SCL kivezetés beállítására
  I2CInit();    //I2C inicializálása
  lcd_begin(0x3F,20,4);               //A kijelző beállítása
  lcd_backlight();                    //háttérvilágítás bekapcsolása
  lcd_setCursor(0,0);                 //LCD kurzor a 1. sor 1. karakter pozícióba
  lcd_print("Magyar ékezetes");       //Írás a kijelzőre a beállított pozíciótól
  lcd_setCursor(0,1);                 //LCD kurzor a 2. sor 6. karakter pozícióba
  lcd_print("Bemutató program"); 
  delay(2000);

  lcd_clear();                        //kijelző törlése
  lcd_setCursor(0,0);                 //LCD kurzor a 1. sor 1. karakter pozícióba
  lcd_print("Írás karkt.-ként"); 
  lcd_setCursor(0,1);                 //LCD kurzor a 1. sor 1. karakter pozícióba
  lcd_write(65);  //"A" betű ASCI kódja 65
  lcd_write(66);
  lcd_write(67);
  lcd_write(68);
  lcd_write(69);
  //ékezetes betűt csak lcd_print()-el lehet írni, mert az két byte-on megy ki UTF-8 kódolással a string-ben
  delay(2000);
  
  //------------------egyéb kijelző kezelő függvények bemutatása----------------------------------------
  //háttérvilágítás ki és bekapcsolása
  lcd_clear();lcd_print("Háttér világitás");lcd_setCursor(0,1);lcd_print("kikapcsolás");
  delay(2000);lcd_noBacklight();delay(1000);lcd_backlight();delay(1000);
  //Cursor pozició villogtatása sötét hátérrel.
  lcd_clear();lcd_print("Blink funkció"); lcd_blink(); delay(3000);lcd_noBlink();
  //Bekapcsoljuk a blink funkciót és a szöveg kiírását követően balra mozdítjuk a kurzort
  lcd_clear();lcd_blink();lcd_print("Cursor áthely.");delay(2000);lcd_setCursor(6,0);;delay(2000);lcd_noBlink();
  //szöveg kiírást követően bekapcsoljuk a kurzort, majd kis idő mulva kikapcsoljuk
  lcd_clear();lcd_print("Cursor on-off");lcd_cursor();delay(3000);
  lcd_noCursor();delay(3000); 
  //kikapcsoljuk a display-t. A világítás marad, de szövegek nem láthatóak, azonban a tartalom nem törlődik, bekapcsoláskor ujra láthatóvá válik
  lcd_clear();lcd_print("Disp. ki és be!");lcd_setCursor(0,1);lcd_print("Világítás marad!");delay(2000);
  lcd_noDisplay();delay(2000);lcd_display();delay(2000);
  //kikapcsoljuk a display-t. Teljes kikapcsolás, a világítás is lekapcsolódik. A tartalmat azonban nem felejti el, visszakapcsoláskor ujra láthatóvá válik az előzőleg kiírt szöveg
  lcd_clear();lcd_print("Disp. teljes ki");lcd_setCursor(0,1);lcd_print("és bekapcsolása");delay(2000);
  lcd_off();delay(2000);lcd_on();delay(2000);

  //---------------Képernyő tartalom eltolása jobbra illetve balra-------------------------------------
  //A DDRAM változtatása nélkül jobbra illetve balra toljuk el a teljes képernyő tartalmat
  //A kiírt szöveg vándorol a képernyőn (lépeget a DDRAM-ban a tartalom), ami az egyik végén
  //kilép, amásik végén belép és fordítva. Négy soros kijelző esetén az első sorban kilépő
  //karakter a harmadik sorban lép be, aztán ami itt kilép a másodikon lépbe, majd a negyedikre
  //kerül át (illetve fordítva)
  lcd_clear();lcd_print("Scroll balra");delay(1000);
  for (byte i=0;i<12;i++) {lcd_scrollDisplayLeft();delay(200);} //A kiírt szöveget többször balra mozdítjuk egy-egy pozícióval
  delay(2000);
  lcd_clear();lcd_print("Scroll jobbra");delay(1000);
  for (byte i=0;i<20;i++) {lcd_scrollDisplayRight();delay(200);} //A kiírt szöveget többször jobbra mozdítjuk egy-egy pozícióval
  delay(2000);
  
  //kiírjuk az "Autoscroll:" szöveget és bekapcsoljuk az autoscroll funkciót. Kiírunk 10 számot,
  //és az eredetileg kiírt szöveg balra tolódik egy-egy pozícióval a számok kiírásakor. Ami a sor
  //elején vagy végén kilép, az a következő sorban belép (négysorosnál a sorrend 1-3-2-4. sor)
  //---------------Autóscroll funkció balra-------------------------------------------------------------
  lcd_setCursor(0,0);
  lcd_clear();  lcd_print("Autoscroll bal");delay(3000);
  lcd_leftToRight();   //Az írási irány balról jobbra, de ekkor az autoscroll balra mozdítja a szöveget
  lcd_autoscroll();    //Autóscroll funkció bekapcsolása. Ennek hatására nem a cursor mozdul el egy karakter
                       //kiírásakor, hanem a teljes képernyő tartalom. Ami a sor elején kilép, az a második sor végén
                       //belép. Négysoros kijelzőnél az első sorból kilépő karakter a harmadik sorban lép be 
  lcd_setCursor(10,1);
  for (byte i=0; i<10; i++) {lcd_print_long(i,0,0);delay(300);} 
  lcd_noAutoscroll();
  delay(3000);
  //---------------Autóscroll funkció jobbra--------------------------------------------------------------
  lcd_setCursor(0,0);
  lcd_clear();  lcd_print("Autoscroll jobb");delay(3000);
  lcd_rightToLeft();  //Az írási irány jobbról balra, de ekkor az autoscroll jobbra mozdítja a szöveget
  lcd_autoscroll();   //Autóscroll funkció bekapcsolása. Ennek hatására nem a cursor mozdul el egy karakter
                      //kiírásakor, hanem a teljes képernyő tartalom. Ami a sor végén kilép, az a második sor elején
                      //belép. Négysoros kijelzőnél az első sorból kilépő karakter a harmadik sorban lép be 
  lcd_setCursor(10,1);
  for (byte i=0; i<10; i++) {lcd_print_long(i,0,0);delay(300);} 
  lcd_noAutoscroll(); 
  lcd_leftToRight(); 
  delay(3000);

  //---------------Jobbra írási mód (alaphelyzetnek megfelelő)---------------------------------------------
  lcd_clear();lcd_print("Jobbra írás:");delay(3000);
  lcd_leftToRight(); 
  lcd_setCursor(0,1);
  for (byte i=0; i<10; i++) {lcd_print_long(i,0,0);delay(300);} 
  delay(3000);
  
  //---------------Balra írási mód karakterenkénti írással-------------------------------------------------
  lcd_clear();lcd_setCursor(0,0);lcd_print("Balra írás:");
  lcd_setCursor(0,1);lcd_print("Megl.szöv:");delay(3000);    //A sor elején található szövegre ráír
  lcd_rightToLeft();
  lcd_setCursor(10,1);
  for (byte i=0; i<10; i++) {lcd_print_long(i,0,0);delay(300);} 
  delay(3000);
  lcd_leftToRight();  //normál jobbra írási mód visszaállítása

  //---------------Teljes magyar ékezetkészlet bemutatása (csak kis betűk férnek el) ----------------------
  lcd_clear();lcd_setCursor(0,0);lcd_print("Ékezetes betűk:");
  lcd_setCursor(0,1);lcd_print("ÁáÉéÖöŐőÜüűŰúÚÍí");delay(4000);

  //---------------Különböző változó típusok írása---------------------------------------------------------
  lcd_clear();lcd_setCursor(0,0);lcd_print("Long (8 hossz):");      //Második paraméter a kiírás hossza (0 esetén pontos értéket ír).
                                                                    //Harmadik paraméter a feltöltés: 0=szóköz 1="0" karakter.
  lcd_setCursor(0,1);lcd_print_long((long) 52312,8,0);
  delay(2000);
  lcd_clear();lcd_setCursor(0,0);lcd_print("Long (zerofill):");
  lcd_setCursor(0,1);lcd_print_long((long) -52312,8,1);
  delay(2000);
  lcd_clear();lcd_setCursor(0,0);lcd_print("Float: (4.2 hossz):");
  lcd_setCursor(0,1);lcd_print_float((float)54.23923,4,2,0);         //Masodik paraméter a minimális egész hossz (0 estén pntos hosszúságban ír),
                                                                     //harmadik paraméter a tizedesek száma. Ha a megadott tizedesek száma kisebb, 
                                                                     //mint az értékes tizedesek, akkor kerekít. Negyedik paraméter a feltöltés: 0=szóköz
                                                                     //1="0" karakter.
  delay(2000);
  lcd_clear();lcd_setCursor(0,0);lcd_print("Float: (zerofill):");
  lcd_setCursor(0,1);lcd_print_float((float)54.23923,4,2,1);         
  delay(2000);
  lcd_clear();lcd_setCursor(0,0);lcd_print("Dátum (no cent):");     
  lcd_setCursor(0,1);lcd_print_date(22,03,20,0);                     //Paraméterek: év, hó, nap. Negyedik paraméter az évszázad kijelzés: 0=csak két
                                                                     //karakteren írja ki az évet, 1=az évet négy karakteren írja ki.
  delay(2000);
  lcd_clear();lcd_setCursor(0,0);lcd_print("Dátum (cent):");
  lcd_setCursor(0,1);lcd_print_date(2022,03,20,1); 
  delay(2000);
  lcd_clear();lcd_setCursor(0,0);lcd_print("Dátum (no sec):");       
  lcd_setCursor(0,1);lcd_print_time(5,9,25,0);                       //paraméterek: óra, perc, másodperc. Negyedik paraméter a másodperc kiírás 
                                                                     //0-nem írja ki a másodpercet (óó:pp), 1=kiírja a másodpercet is (óó:pp:mm)
  delay(2000);
  lcd_clear();lcd_setCursor(0,0);lcd_print("Dátum (sec):");
  lcd_setCursor(0,1);lcd_print_time(5,9,25,1); 
}

void loop()
{
}
